from loguru import logger
import psycopg2
import psycopg2.extras
import os

class AbstractTsDbMixin(object):
    def __init__(self, config, name, inQueue, experiment):
        logger.info("constructor called")
        self.config = config
        self.name = name
        self.connection = None
    
    def connectDb(self):
        dbHost = self.config["database"]["host"]
        dbUser = self.config["database"]["user"]
        dbPassword = self.config["database"]["password"]
        if dbPassword == "$ENV$":
            dbPassword = os.environ["DB_PASSWORD"]
        dbName = self.config["database"]["name"]

        logger.info(f"Connect to database for {self.name}")
        connInfo = f"user={dbUser} host={dbHost} dbname={dbName} sslmode=require"
        if dbPassword != "$NONE$":
            connInfo += f" password={dbPassword}"
        self.connection = psycopg2.connect(connInfo)
        self.connection.autocommit = False
        logger.info("Connection to database established")

    def disconnectDb(self):
        logger.info(f"Disonnect from database for {self.name}")
        if self.connection:
            self.connection.close()

    def write(self, experiment, dataObject):
        raise NotImplementedError()


