from loguru import logger
from AbstractSinkHandler import AbstractSinkHandler
from EGM1mdTsDbMixin import EGM1mdTsDbMixin

class EGM1mdTsDbSinkHandler(AbstractSinkHandler, EGM1mdTsDbMixin):
    def __init__(self, config, name, inQueue, experiment):
        super().__init__(config, name, inQueue, experiment)
        logger.info("constructor called")

    def init(self):
        logger.info("init")
        self.connectDb()

    def deinit(self):
        logger.info("deinit")
        self.disconnectDb()

    def sinkAction(self, dataObject):
        logger.info(f"sink {self.name} received {dataObject} for experiment {self.experiment}")
        self.write(self.experiment, dataObject)